// Copyright 2022 The Tint Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include "src/tint/ast/f16.h"

#include "src/tint/program_builder.h"

TINT_INSTANTIATE_TYPEINFO(tint::ast::F16);

namespace tint::ast {

F16::F16(ProgramID pid, NodeID nid, const Source& src) : Base(pid, nid, src) {}

F16::F16(F16&&) = default;

F16::~F16() = default;

std::string F16::FriendlyName(const SymbolTable&) const {
    return "f16";
}

const F16* F16::Clone(CloneContext* ctx) const {
    auto src = ctx->Clone(source);
    return ctx->dst->create<F16>(src);
}

}  // namespace tint::ast
