// Copyright 2020 The Tint Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Vertex shader
const pos = array<vec2<f32>, 3>(vec2(0.0, 0.5),
                                vec2(-0.5, -0.5),
                                vec2(0.5, -0.5));

@vertex
fn vtx_main(@builtin(vertex_index) VertexIndex : u32)
         -> @builtin(position) vec4<f32> {
  return vec4<f32>(pos[VertexIndex], 0.0, 1.0);
}

// Fragment shader
@fragment
fn frag_main() -> @location(0) vec4<f32> {
  return vec4<f32>(1.0, 0.0, 0.0, 1.0);
}
