// Copyright 2021 The Tint Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <vector>

#include "src/tint/fuzzers/fuzzer_init.h"
#include "src/tint/fuzzers/tint_reader_writer_fuzzer.h"

namespace tint::fuzzers {

extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
    tint::fuzzers::ReaderWriterFuzzer fuzzer(InputFormat::kSpv, OutputFormat::kHLSL);
    fuzzer.SetDumpInput(GetCliParams().dump_input);
    fuzzer.SetEnforceValidity(GetCliParams().enforce_validity);

    return fuzzer.Run(data, size);
}

}  // namespace tint::fuzzers
